<?
require('cfg/db.php');
require('cfg/db_func.php');
require('cfg/sess.php');

$login_flag = sess_check();

function line($width) {
echo '<br /><img src="images/bpixel.gif" width="' . $width . '" height="1" alt=" - - - - - - " /><br />';
}

?>
<!DOCTYPE html
PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
<title>Paper Management - la bibliothque - Miscellanea</title>
<link rel="stylesheet" type="text/css" href="site.css"/>
<link rel="stylesheet" type="text/css" href="documentation.css"/>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
</head>
<body>
<a name="top"></a>
<?
include('nav/top.php');
?>
<div class="mbody">

<!-- contents ################################ -->
<span class="headerI">Documentation:</span><br />
<span class="headerII">Paper Management Script - la bibliothque</span><br />
<span class="headerIII">Contents</span><br />
<div class="subtext1">


<!-- I -->
<a href="documentation.php#I">I. Overview</a>

<!-- I.1 -->
<ul>
<li><a href="documentation.php#I1">I.1 Data Structure</a></li>
<ul>
<li><a href="documentation.php#I1i">I.1.i Papers Table</a></li>
<li><a href="documentation.php#I1ii">I.1.ii Categories Table</a></li>
<li><a href="documentation.php#I1iii">I.1.iii Users Table</a></li>
</ul>

<!-- I.2 -->
<li><a href="documentation.php#I2">I.2 Instructions</a></li>
<ul>
<li><a href="documentation.php#I2i">I.2.i Managing Categories</a></li>
<li><a href="documentation.php#I2ii">I.2.ii Managing Users</a></li>
<li><a href="documentation.php#I2iii">I.2.iii Adding Data</a></li>
<li><a href="documentation.php#I2iv">I.2.iv Editing Data</a></li>
<li><a href="documentation.php#I2v">I.2.v Viewing Data</a></li>
</ul>
<!-- // I.2 -->
</ul>
<!--// I -->


<!-- II -->
<a href="documentation.php#II">II. Other Notes</a>

<!-- II.1 -->
<ul>
<li><a href="documentation.php#II1">II.1 Styles</a></li>
<li><a href="documentation.php#II2">II.2 HTML</a></li>
<li><a href="documentation.php#II3">II.3 Version History [Revisions]</a></li>
</ul>
<!-- // II-->


<br />
<span id="bold">Last documentation revision: </span> 24 July 2003, Thursday<br />
<span id="bold">Last script revision: </span> 24 July 2003, Thursday<br />
&copy;S. Shyu 2003, all rights reserved.

</div>
<!-- //documentation contents -->
<? line(630); ?>
<a name="I"></a>
<span class="headerI">I. Overview</span>
<div class="level" id="0">This script is written for the purpose of managing papers using a MySQL database (version 4 or higher as of this revision) and displaying them by an assigned category.  One is also able to manage categories within the script, adding and deleting them as desired.  A simple user authentication and management system is also in place - however, any user may delete any other users - there is no advanced system of setting permissions between users as of yet.  Note that this is not designed to be an index of papers that may be searched by detailed fields beyond the paper's category or arbitrarily assigned ID number (that is, bibliographical information, such as publication, publication date, authors, etc. are stored together in a single field and thus it is not possible to perform searches with the script as-is using any of those fields as a criterion; although it would be possible to write a function to search the citation fields for such datat, doing so would be decidedly less efficient and ideal.)<br /><br />

General note regarding authentication: you must have cookies enabled to use this script's authentication feature.  If you are concerned about privacy, then you should download a browser with built-in cookie management functions, such as <a href="http://www.mozilla.org/">Mozilla</a> (whose cookie management features will enable selective acceptance of cookies).</div>

<div class="level" id="1">
<a name="I1"></a>
<span class="headerII">I.1 Data Structure</span><br />
The data structure as defined for the script is fairly rigid.  The script has been designed around the data structure strictly and it does not allow for changes to the pre-defined table structure without modifications of the script.  While changes to the modification of the data structure are possible even when data already exists, making such modifications would require careful rewriting of the script, and client-side testing would be ideal to ensure that the data is not damaged when the revised script is applied to the existing data.

<div class="level" id="2">
<a name="I1i"></a>
<span class="headerIII">I.1.i Papers Table</span><br />
The <span class="intext_code1">Papers</span> table has this structure:

<pre style="width: 490px;">
+--------------+-------------+------+-----+---------+----------------+
| Field        | Type        | Null | Key | Default | Extra          |
+--------------+-------------+------+-----+---------+----------------+
| ID           | int(11)     |      | PRI | NULL    | auto_increment |
| PaperTitle   | text        | YES  |     | NULL    |                |
| Abstract     | text        | YES  |     | NULL    |                |
| Citation     | text        | YES  |     | NULL    |                |
| LinkNo       | tinytext    | YES  |     | NULL    |                |
| PaperNo      | int(6)      |      | UNI | 0       |                |
| ImgURL       | tinytext    | YES  |     | NULL    |                |
| SubmittedBy  | tinytext    | YES  |     | NULL    |                |
| UpdatedBy    | tinytext    | YES  |     | NULL    |                |
| CategoryID   | varchar(30) | YES  |     | NULL    |                |
| DateCreated  | datetime    | YES  |     | NULL    |                |
| DateModified | datetime    | YES  |     | NULL    |                |
+--------------+-------------+------+-----+---------+----------------+
</pre>

<span class="headerV">Explanation of Fields:</span><br />
<div id="inset">
<span class="intext_code1" id="bold">ID</span> [integer, display size 11]:<br />
The integer by which the papers are sorted within the table.  This is a required field and automatically added and incremented by the database.
</div>

<div id="inset">
<span class="intext_code1" id="bold">PaperTitle</span> [text, maximum 65535 characters]:<br />
The paper's title.
</div>

<div id="inset">
<span class="intext_code1" id="bold">Abstract</span> [text, maximum 65535 characters]:<br />
The paper's abstract.
</div>

<div id="inset">
<span class="intext_code1" id="bold">Citation</span> [text, maximum 65535 characters]:<br />
The paper's full citation.  The format may be arbitrarily chosen by the user inputting the data; the script does not require adherence to any particular stylesheet.
</div>


<div id="inset">
<span class="intext_code1" id="bold">LinkNo</span> [text, maximum 255 characters]:<br />
The paper's link number.  As of this script's writing, the server on which the papers are stored uses a download script to count downloads of particular papers.  When the script displays paper data for the user that requests so, it will output an appropriate link based upon this number.  It will be used as such:<br />
<div class="intext_code1">http://[base URL]/download.cgi?[LinkNo]</div>
For example:<br />
<div class="intext_code1">http://biocomplexity.indiana.edu/cgi-bin/download.cgi?01a</div>
</div>

<div id="inset">
<span class="intext_code1" id="bold">PaperNo</span> [integer, maximum length 6, required]:<br />
The paper's number, as arbitrarily assigned.  This is a required field and must be specified; the database will assign the default value of 0 otherwise.  Note that this value must also be unique and attempting to add additional papers without specifying a number will yield errors as the default of 0 will have already been assigned to a paper.
</div>

<div id="inset">
<span class="intext_code1" id="bold">ImgURL</span> [text, maximum 255 characters]:<br />
The URL to an image to displayed with the paper data, if there exists one.  Like with the <span class="intext_code1">LinkNo</span> field, a base URL will be used and this field will only contain the data to be appended.<br />
<div class="intext_code1">http://[base URL]/[image]</div>
For example:<br />
<div class="intext_code1">http://biocomplexity.indiana.edu/images/paper01.gif</div>
</div>

<div id="inset">
<span class="intext_code1" id="bold">SubmittedBy</span> [text, maximum 255 characters]:<br />
The user name of the person who submitted the data to the database.  The user name will be determined via the script's authentication system.
</div>

<div id="inset">
<span class="intext_code1" id="bold">UpdatedBy</span> [text, maximum 255 characters]:<br />
The user name of the person last modified a particular record.  The user name will be determined via the script's authentication system.
</div>

<div id="inset">
<span class="intext_code1" id="bold">CategoryID</span> [text, maximum 30 characters]:<br />
The category ID of a paper.  The category ID will correspond with a category in the <span class="intext_code1">Categories</span> table.
</div>

<div id="inset">
<span class="intext_code1" id="bold">DateCreated</span> [datetime]:<br />
The date and time when the record was submitted.
</div>

<div id="inset">
<span class="intext_code1" id="bold">DateModified</span> [datetime]:<br />
The date and time when the record was last modified.
</div>

In spite of the limits described above, the script imposes arbitrary limits that are lower than those described above upon the lengths of the fields into which the user will enter data.  The lengths are decidedly generous and exist only to prevent accidental data duplication [this feature is not fully implemented as of revision 0.5&beta;] (i.e., as much of the data will be entered via the copy and paste functions, the data limits imposed should prevent problems in the event a user accidentally 'pastes' the text twice into a field).  These limits are as follows:<br />
<br />
<span class="headerV">Field (character limit)</span>
<div class="level" id="3">
PaperTitle (1024)<br />
Abstract (16384)<br />
Citation (8192)<br />
LinkNo (5)<br />
ImgURL (128)<br />
CategoryID (128)<br />
</div>


</div>

<div class="level" id="2">
<a name="I1ii"></a>
<span class="headerIII">I.1.ii Categories Table</span><br />
The <span class="intext_code1">Categories</span> table has this structure:

<pre style="width: 520px;">
+------------+-------------+------+-----+---------+----------------+
| Field      | Type        | Null | Key | Default | Extra          |
+------------+-------------+------+-----+---------+----------------+
| ID         | int(11)     |      | PRI | NULL    | auto_increment |
| Category   | tinytext    |      |     |         |                |
| CategoryID | varchar(30) |      | UNI |         |                |
| Overview   | text        | YES  |     | NULL    |                |
+------------+-------------+------+-----+---------+----------------+
</pre>

<span class="headerV">Explanation of Fields:</span><br />
<div id="inset">
<span class="intext_code1" id="bold">ID</span> [integer, display size 11]:<br />
An integer by which the papers are sorted within the table.  This is a required field and is automatically added and incremented by the database.
</div>

<div id="inset">
<span class="intext_code1" id="bold">Category</span> [text, maximum 255 characters]:<br />
The name of the category into which papers may be classified.
</div>

<div id="inset">
<span class="intext_code1" id="bold">CategoryID</span> [text, maximum 255 characters]:<br />
A (shorter) ID, usually a combination of numbers and only a few letters by which the category will be identified.  The category ID specified by the user must be unique (relative to other category IDs stored within this table) or the database will refuse the input.
</div>

<div id="inset">
<span class="intext_code1" id="bold">Overview</span> [text, maximum 65535 characters]:<br />
An overview of the category.  This will be an introduction to be displayed with each set of papers corresponding to a particular category.
</div>
</div>



<div class="level" id="2">
<a name="I1iii"></a>
<span class="headerIII">I.1.iii Users Table</span><br />

The <span class="intext_code1">Users</span> table has this structure:

<pre style="width: 595px;">
+---------------+-------------+------+-----+---------------------+----------------+
| Field         | Type        | Null | Key | Default             | Extra          |
+---------------+-------------+------+-----+---------------------+----------------+
| user_id       | int(8)      |      | PRI | NULL                | auto_increment |
| username      | varchar(30) |      | UNI |                     |                |
| password      | varchar(32) |      |     |                     |                |
| fullname      | varchar(35) |      |     |                     |                |
| email         | varchar(60) |      | UNI |                     |                |
| create_date   | datetime    |      |     | 0000-00-00 00:00:00 |                |
| last_visited  | datetime    | YES  |     | NULL                |                |
+---------------+-------------+------+-----+---------------------+----------------+
</pre>

<span class="headerV">Explanation of Fields:</span><br />
<div id="inset">
<span class="intext_code1" id="bold">user_id</span> [integer, display size 8]:<br />
An integer by which the papers are sorted within the table.  This is a required field and is automatically added and incremented by the database.
</div>

<div id="inset">
<span class="intext_code1" id="bold">username</span> [text, maximum 30 characters, required]:<br />
The username of a user.  This is a required field and must be unique (relative to other <span class="intext_code1">username</span>s stored within this table or the database will not accept the input.
</div>

<div id="inset">
<span class="intext_code1" id="bold">password</span> [text, maximum 32 characters, required]:<br />
The password of a user.  The script will store first encode paasswords via the PHP <span class="intext_code1">md5()</span> function, which produces a 32-character encoded string of the function's input.  This is a one-way 'encryption' process and it is not easily decrypted afterwards; this is done for security reasons.  The script imposes a 32-character limit on passwords, but regardless of what the input for this field, it will eventually be stored as a 32-character string.
</div>

<div id="inset">
<span class="intext_code1" id="bold">fullname</span> [text, maximum 35 characters, required]:<br />
The actual, given name of a user (or any form thereof).  
</div>

<div id="inset">
<span class="intext_code1" id="bold">email</span> [text, maximum 60 characters, required]:<br />
The e-mail address of a user. This must be unique as well, to prevent the same user from re-registering (with the same e-mail address).
</div>


<div id="inset">
<span class="intext_code1" id="bold">create_date</span> [datetime, required]:<br />
The date the user's account was created.
</div>

<div id="inset">
<span class="intext_code1" id="bold">last_visited</span> [datetime]:<br />
The date and time when the user last visited the site.  Null if the user has not visited the site before.  Recorded upon the user's logging in.
</div>

</div>



<a name="I2"></a>
<span class="headerII">I.2 Instructions</span><br />
Usage of this script is fairly self-explanatory.  This section will contain specific notes regarding each section's usage, if any.  If you encounter errors when submitting data, you might also look here to see the specific notes regarding data input.  Please see <a href="#I1">I.1 Data Structure</a> for detailed information regarding data structure if you continue to encounter errors upon inputting data.<br /><br />
<span class="headerV">General Notes:</span>
<div class="text-inset" id="c">
<ol>
<li>Each section that allows for data manipulation has a separate function for viewing and editing data.  Although both will display the data, the function for editing data will allow you to select a record for editing and will not display all of the data associated with each record, whereas the function for viewing will enable the user to view the full record.</li>
<li>JavaScript may be utilized to validate data input, ensuring it does not violate any imposed restrictions; however, this feature has not been implemented as of yet, but will in the near future.</li>  
<li>When editing a record, there will be a checkbox present that will allow you to delete the data.  If the user checks this box and the clicks the <span class="intext_code2">Edit [paper, category, user]</span> button, then the record will be irrevocably deleted.</li>
</ol>
</div>
<br /><br />

<div class="level" id="2">
<a name="I2i"></a>
<span class="headerIII">I.2.i Managing Categories</span><br />
The category ID you assign to a category must be unique.  If it is not, then you will receive an error upon attempting to add a record.
</div>

<div class="level" id="2">
<a name="I2ii"></a>
<span class="headerIII">I.2.ii Managing Users</span><br />
All fields are required when adding a user.  You will receive errors if you do not complete all fields.<br /><br />
When editing users, if you do not desire to change their password, then leave the password fields blank.  If you wish to change the user's password, then fill in new passwords into the appropriate fields.<br /><br />
As passwords cannot be retrieved and decrypted from the format in which they are encoded in the database, you may only change an existing user's password.  (Viewing it is presently impossible with this script.)  Thus, if a user has forgotten their password, the password's retrieval is impossible - it may only be resetted instead.<br /><br />
The user name and e-mail address you specify upon adding a user must be unique.  If either user name or e-mail exists within the database, you will receive an error.
</div>

<div class="level" id="2">
<a name="I2iii"></a>
<span class="headerIII">I.2.iii Adding Data</span><br />
There are currently no notes for this section.
</div>

<div class="level" id="2">
<a name="I2iv"></a>
<span class="headerIII">I.2.iv Editing Data</span><br />
There are currently no notes for this section.
</div>


<div class="level" id="2">
<a name="I2v"></a>
<span class="headerIII">I.2.v Viewing Data</span><br />
There are currently no notes for this section.
</div>

<? line(630); ?>
<br />
<a name="II"></a><span class="headerI">II. Other Notes</span>
<div class="level" id="0">
These are included for reference and are not of significant importance to the script or its operation.
</div>

<div class="level" id="1">
<a name="II1"></a>
<span class="headerII">II.1 Styles</span><br />
The site uses one master stylesheet to define the styles used within it - named <span class="intext_code1">style.css</span> as of this writing.  The styles have no particular organization within them, but the ones used primarily on the site (of those defined) are these:<br />
<br />

<div class="text_inset" id="b">
<span class="intext_code1" id="bold">.header3</span> [for page headers]<br />
		<span id="css">{
		font-size: 16pt;<br />
		font-variant: small-caps;<br />
		font-weight: bold;<br />
		margin-bottom: 20px }</span>
</div>

<div class="text_inset" id="b">
<span class="intext_code1" id="bold">.subheader2</span> [for smaller headers, usually in-text]<br />
		<span id="css">{
		font-size: 10pt;<br />
		font-weight: bold;<br />
		margin-top: 5px;<br />
		margin-bottom: 2px;<br />
		color: #767878;
		}</span>
</div>

<div class="text_inset" id="b">
<span class="intext_code1" id="bold">.subtext1</span> [for text within the page (for data, the font defined in the <span class="intext_code1">BODY</span> section of the stylesheet is used).]<br />
		<span id="css">{
		font-family: Trebuchet MS, Trebuchet;<br />
		font-size: 10pt;<br />
		margin-left: 13px;<br />
		margin-bottom: 25px;
		}</span>
</div>

</div>

<div class="level" id="1">
<a name="II2"></a>
<span class="headerII">II.2 HTML</span><br /><br />
This script management interface is written in XHTML 1.0 as defined by the World Wide Web Consortium (w3.org).  The syntax has not been validated as of yet, but the majority of it should be compliant.  Additionally, the site uses cascading style sheets (CSS) to define the styles used within the site.
</div>


<div class="level" id="1">
<a name="II3"></a>
<span class="headerII">II.3 Version History [Revisions]</span><br /><br />

<span class="headerV">paper management / version 0.77&beta; / 13 aug 2003 [wed]</span><br />
Various small changes throughout; no major modifications.  Small tidying and organization of script functions.
<div class="text_inset" id="c" style="padding-left: 30px;">
<li>Form validation mostly complete the script - added form validation in the script and JavaScript in this revision.</li>
<li></li>
</div>
<br /><br />

<span class="headerV">paper management / version 0.75&beta; / 4 aug 2003 [mon]</span><br />
More code organization this time around, minor optimization.
<div class="text_inset" id="c" style="padding-left: 30px;">
<li>Most pages with more optimized code; additional room for more still).</li>
<li>Search form allows spaces now - the JavaScript validator is not all that fool-proof because of oddities in how it apparently handles regular expressions (vs. PHP's regexps or the regexps used in preg_match).</li>
<li>Paper view script (public) overhauled slightly in how it displays data.  Much neater and trimmer now; odd problem with line-break tags at the bottom, though.</li>
</div>
<br /><br />


<span class="headerV">paper management / version 0.73&beta; / 31 july 2003 [thu]</span><br />
Additional code organization in this revision and other things that have since been forgotten.  
<div class="text_inset" id="c" style="padding-left: 30px;">
<li>Most pages with more optimized code; additional room for more still.</li>
<li>Other stuff.</li>
</div>
<br /><br />

<span class="headerV">paper management / version 0.7&beta; / 29 july 2003 [tue]</span><br />
Added validation for user section fields and fields used in the public scripts (the view script and public search script).  Category fields and paper fields will have validation later.  Some code clean-up performed with more to come later.
<div class="text_inset" id="c" style="padding-left: 30px;">
<li>Validation added via both JavaScript and script-side (for security).</li>
<li>User section fields have validation now; not fool-proof but fairly good.</li>
<li>Public search page and view page have valdiation (to prevent malicious input).</li>
<li>Cleaned up lots of code in the base administration script, though still a bit rough-looking (but better).</li>
<li>Fixed some typographical errors.</li>
<li>Optimized code slightly (much remains to be done.)</li>
</div>
<br /><br />

<span class="headerV">paper management / version 0.65&beta; / 25 july 2003 [fri]</span><br />
Mostly additions, no code clean-up as of yet.<br />
<div class="text_inset" id="c" style="padding-left: 30px;">
<li>Search page for users outside of the administration area (public search); pagination of results available as well.</li>
<li>External view data page mostly complete.</li>
<li>Overview implemented for categories section.</li>
</div>
<br /><br />

<span class="headerV">paper management / version 0.6&beta; / 24 july 2003 [thu]</span><br />
Code has not been tidied up very much, but a few new features have been added.  The code, actually, has probably become a bit messier, especially on the newer pages.  There's not an easy to handle variables when they can sometimes be posted and other times passed through the query string.  As of now, the 'solution' implemented works - it is just a bit inefficient. However, as site usage should be relatively light, this should not pose much problem for now.<br />
<div class="text_inset" id="c" style="padding-left: 30px;">
<li>Ability to sort records in view data page</li>
<li>Basic search function, for papers table only</li>
<li>Pagination of results when viewing papers </li>
<li>Pagination of results when browsing papers for editing</li>
<li>Ability to edit from search results</li>
<li>Basic view data page for use outside of the script administration area</li>
</div>
<br /><br />

<span class="headerV">paper management / version 0.5&beta; / 23 july 2003 [wed]</span><br />
Still un-named, but the basic script complete with simple authentication (with PHP sessions) is complete. Authentication could be more secure, as PHP sesssions are not totally secure; additionally, there may be some bugs present, but basic use at this time does not reveal any significant ones.  Data is manipulated via a MySQL server.  The script is still not very dynamic with regard to data handling, but this intentional as broader functions (mass-moves, mass-deletes, etc.) were beyond the function of this script.  However, mass-changing of certain fields - such as the category field - is planned for the future.  This script is also custom-designed, so configuration/naming of tables and databases still requires much manual modification.<br /><br />

<span class="headerV">Basic Feature List:</span><br />
<div class="text_inset" id="c" style="padding-left: 30px;">
<li>Adding, editing and deletion of categories</li>
<li>Adding, editing and deletion of users</li>
<li>Adding, editing and deletion of papers</li>
<li>Mostly documented (the script itself excepted)</li>
<li>Ability to sort by various fields</li>
<li>Ability to display papers outside of script by various fields (in particular by category)</li>

</div>
</div>

<br /><br />


<?
include('nav/bottom.php');
?>

</body>
</html>